#pragma once

#include <string>
#include <boost/fusion/include/define_struct.hpp>
#include <boost/fusion/include/adapt_struct.hpp>

#include "../simulation/Simulation.h"
#include "../simulation/Beat.h"
#include "../simulation/Math.h"

BOOST_FUSION_ADAPT_STRUCT(
	::math::Vec2,
	(float, x)
	(float, y)
)

BOOST_FUSION_ADAPT_TPL_STRUCT(
	(BallInfo),
	(simulation::Ball) (BallInfo),
	(BallInfo, information)
	(::math::Vec2, position)
	(::math::Vec2, speed)
)

BOOST_FUSION_ADAPT_TPL_STRUCT(
	(LineInfo),
	(simulation::Line) (LineInfo),
	(::math::Vec2, starting_point)
	(::math::Vec2, end_point)
	(simulation::LineKind, line_kind)
)
